<template>
  <v-container>
    <v-row justify="space-between mx-5">
      <template v-if="editingButtons">
        <v-col cols="7">
          <button-editor
            ref="buttonEditor"
            v-model="activeTemplatesSync"
            :selected-template.sync="selectedTemplate"
            :labels="labels"
            :default-templates="defaultTemplates"
            @finished="editingButtons = false"
          />
        </v-col>
        <v-col cols="1">
          <dez-fab
            class="ma-5"
            icon="mdi-check"
            color="success"
            small
            :tooltip="$t('creation-bar.tooltip.validate')"
            @click="toggleEditor"
          />
        </v-col>
      </template>
      <v-col
        v-else
        cols="12"
        md="8"
        lg="9"
      >
        <creation-button
          v-for="template, index in activeTemplatesSync"
          :key="index"
          v-longclick="onMouseHold"
          :template="template"
          :selected-template="selectedTemplate"
          class="my-2 mx-2"
          :key-num="index + 1"
          @mousedown="onMouseDown(template)"
        />
        <dez-fab
          class="ma-5"
          :icon="activeTemplatesSync.length ? 'mdi-pencil' : 'mdi-plus'"
          :color="$store.state.secondaryColor"
          small
          :tooltip="$t('creation-bar.tooltip.buttons')"
          @click="toggleEditor"
        />
      </v-col>
      <v-col cols="12" md="4" lg="2">
        <tag-field
          ref="tag"
          :actions="actions"
          :label="actions.getSelected()"
          :field-label="$t('creation-bar.label.tagField')"
        />
      </v-col>
      <v-col cols="12" lg="1">
        <dez-fab
          color="warning"
          icon="mdi-delete"
          :tooltip="$t('creation-bar.tooltip.delete')"
          :disabled="!!actions.getSelected()"
          @click="() => actions.deleteSelected(true, true)"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, VModel, PropSync, Ref,
} from 'vue-property-decorator';
import type AnalysisActions from '@/logic/AnalysisActions';
import type {
  Label, LabelId, LabelTemplate, Duration, Onset, Staff,
} from '@/data';

import { FilterStyleGenerator } from '@/logic/FilterStyleGenerator';
import DezFab from '@/vuejs/components/utils/DezFab.vue';
import CreationButton from './CreationButton.vue';
import ButtonEditor from './ButtonEditor.vue';
import TagField from './editor-fields/TagField.vue';

// Directives
// TODO: before merging, if we decide to keep this library, add type and use normal import
// eslint-disable-next-line @typescript-eslint/no-var-requires
const { longClickDirective } = require('vue-long-click');

const longClickInstance = longClickDirective({ delay: 400, interval: 50 });

@Component({
  components: {
    ButtonEditor,
    CreationButton,
    TagField,
    DezFab,
  },
  directives: {
    longclick: longClickInstance,
  },
})
export default class CreationBar extends Vue {
  @Prop({ required: true })
  actions!: AnalysisActions;

  @Prop({ default: null })
  position!: Onset | null;

  @Prop({ default: false })
  playing!: boolean;

  @VModel()
  selectedTemplate!: LabelTemplate | null;

  @PropSync('activeTemplates')
  activeTemplatesSync!: LabelTemplate[];

  @Prop()
  defaultTemplates!: LabelTemplate[];

  @Prop()
  labels!: Record<LabelId, Label>;

  @Prop()
  staves!: Staff[];

  @Ref()
  buttonEditor?: ButtonEditor;

  editingButtons = false;

  // Open or close the button
  toggleEditor() {
    // If currently editing, push search before closing
    if (this.editingButtons) {
      this.buttonEditor?.pushSearch();
      this.editingButtons = false;
    } else {
      this.editingButtons = true;
    }
  }

  getCssClasses = FilterStyleGenerator.getCssClassNames;

  @Ref()
  tag!: TagField;

  // Create a new label on button click (during play)
  // Otherwise simply set the selected template, and deselect any label
  onMouseDown(template: LabelTemplate) {
    this.selectedTemplate = template;
    // Reset the long press ID, to avoid it being called on wrong label
    this.longPressLabelId = null;

    if (this.position !== null && this.playing) {
      const onset = this.position;
      const duration = 4 as Duration;
      const lastStaffId = this.selectedTemplate?.staffId;
      const staff = this.actions.findFreeStaff(onset, duration, this.staves, lastStaffId);
      const id = this.actions.createLabel();
      this.actions.updateLabel(id, 'onset', onset);
      this.actions.updateLabel(id, 'duration', duration);
      this.actions.updateLabel(id, 'staffId', staff);
      this.actions.select(id, true);
      // Set the long press id in case onMouseHold is called
      this.longPressLabelId = id;
    } else {
      this.actions.select(null);
    }
  }

  onMouseHold() {
    // If no label was created on first press, ignore
    if (this.longPressLabelId === null) return;

    // If no label, or not playing, or playing in wrong spot, reset state
    const label = this.actions.getLabel(this.longPressLabelId);

    if (label === null
      || this.position === null
      || this.playing === false
      || label.onset >= this.position) {
      this.longPressLabelId = null;
      return;
    }

    // Update the label so it matches the current play position
    this.actions.updateLabel(
      this.longPressLabelId,
      'duration',
      (this.position - label.onset) as Duration,
    );
  }

  longPressLabelId: LabelId | null = null;

  // Focus the tag field if a label is selected
  public focus(): void {
    if (this.actions.getSelected() !== null) this.tag.focus();
  }
}
</script>
<style scoped lang="scss">
.type-background {
  opacity: 0.2;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background-color: var(--label-color, white);
}
</style>
